﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;
using System.IO;

namespace GalilTools
{
    public partial class Form1 : Form
    {
        #region 宣告狀態參數

        string RPA, RPB, RPC, RPD;
        string TPA, TPB, TPC, TPD;
        string Motion_X, Motion_Y, Motion_Z, Motion_W;
        string Motor_X, Motor_Y, Motor_Z, Motor_W;
        Color Forward_X, Forward_Y, Forward_Z, Forward_W;
        Color Reverse_X, Reverse_Y, Reverse_Z, Reverse_W;
        Color Home_X, Home_Y, Home_Z, Home_W;
        Color MotionColor_X, MotionColor_Y, MotionColor_Z, MotionColor_W;
        Color MotorColor_X, MotorColor_Y, MotorColor_Z, MotorColor_W;

        string StopCode_X, StopCode_Y, StopCode_Z, StopCode_W;

        #endregion

        public Form1()
        {
            InitializeComponent();
        }

        Galil.Galil DMC_1 = new Galil.Galil();

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                DMC_1.address = " ";
                this.Text = string.Format("GalilTools [ver 1.0.0] {0}", DMC_1.connection());
                MotorStatus();
                G_StatusCheck_Tick();
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                MessageBox.Show("連線失敗，請檢查連線。");
                this.Text = string.Format("GalilTools [ver 1.0.0]" + "  Offline");
                //this.Close();
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        #region X、Y、Z、W軸 啟動/停止/急停
              
        //停止
        private void btn_Stop_Click(object sender, EventArgs e)
        {
            try
            {               
                DMC_1.command("ST");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        //急停
        private void btn_AB_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("AB");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_Start_X_Click(object sender, EventArgs e)
        {
            if (txt_PRPA_X.Text == "" || txt_SP_X.Text == "" || txt_AC_X.Text == "" || txt_DC_X.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (pnl_MotionStatus_X.BackColor == Color.LawnGreen)
                    {
                        if (rdo_PA_X.Checked == true)
                        {
                            if (rdo_Forward_X.Checked == true)
                            {
                                DMC_1.command("PA" + txt_PRPA_X.Text);
                            }
                            else if (rdo_Reverse_X.Checked == true)
                            {
                                DMC_1.command("PA-" + txt_PRPA_X.Text);
                            }
                        }
                        else if (rdo_PR_X.Checked == true)
                        {
                            if (rdo_Forward_X.Checked == true)
                            {
                                DMC_1.command("PR" + txt_PRPA_X.Text);
                            }
                            else if (rdo_Reverse_X.Checked == true)
                            {
                                DMC_1.command("PR-" + txt_PRPA_X.Text);
                            }
                        }
                        DMC_1.command("SP" + txt_SP_X.Text);
                        DMC_1.command("AC" + txt_AC_X.Text);
                        DMC_1.command("DC" + txt_DC_X.Text);
                        DMC_1.command("BGA");
                    }
                    else
                    {
                        MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_Start_Y_Click(object sender, EventArgs e)
        {
            if (txt_PRPA_Y.Text == "" || txt_SP_Y.Text == "" || txt_AC_Y.Text == "" || txt_DC_Y.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (pnl_MotionStatus_Y.BackColor == Color.LawnGreen)
                    {
                        if (rdo_PA_Y.Checked == true)
                        {
                            if (rdo_Forward_Y.Checked == true)
                            {
                                DMC_1.command("PA," + txt_PRPA_Y.Text);
                            }
                            else if (rdo_Reverse_Y.Checked == true)
                            {
                                DMC_1.command("PA,-" + txt_PRPA_Y.Text);
                            }
                        }
                        else if (rdo_PR_Y.Checked == true)
                        {
                            if (rdo_Forward_Y.Checked == true)
                            {
                                DMC_1.command("PR," + txt_PRPA_Y.Text);
                            }
                            else if (rdo_Reverse_Y.Checked == true)
                            {
                                DMC_1.command("PR,-" + txt_PRPA_Y.Text);
                            }
                        }
                        DMC_1.command("SP," + txt_SP_Y.Text);
                        DMC_1.command("AC," + txt_AC_Y.Text);
                        DMC_1.command("DC," + txt_DC_Y.Text);
                        DMC_1.command("BGB");

                    }
                    else
                    {
                        MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_Start_Z_Click(object sender, EventArgs e)
        {
            if (txt_PRPA_Z.Text == "" || txt_SP_Z.Text == "" || txt_AC_Z.Text == "" || txt_DC_Z.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (pnl_MotionStatus_Z.BackColor == Color.LawnGreen)
                    {
                        if (rdo_PA_Z.Checked == true)
                        {
                            if (rdo_Forward_Z.Checked == true)
                            {
                                DMC_1.command("PA,," + txt_PRPA_Z.Text);
                            }
                            else if (rdo_Reverse_Z.Checked == true)
                            {
                                DMC_1.command("PA,,-" + txt_PRPA_Z.Text);
                            }
                        }
                        else if (rdo_PR_Z.Checked == true)
                        {
                            if (rdo_Forward_Z.Checked == true)
                            {
                                DMC_1.command("PR,," + txt_PRPA_Z.Text);
                            }
                            else if (rdo_Reverse_Z.Checked == true)
                            {
                                DMC_1.command("PR,,-" + txt_PRPA_Z.Text);
                            }
                        }
                        DMC_1.command("SP,," + txt_SP_Z.Text);
                        DMC_1.command("AC,," + txt_AC_Z.Text);
                        DMC_1.command("DC,," + txt_DC_Z.Text);
                        DMC_1.command("BGC");
                    }
                    else
                    {
                        MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_Start_W_Click(object sender, EventArgs e)
        {
            if (txt_PRPA_W.Text == "" || txt_SP_W.Text == "" || txt_AC_W.Text == "" || txt_DC_W.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (pnl_MotionStatus_Z.BackColor == Color.LawnGreen)
                    {
                        if (rdo_PA_W.Checked == true)
                        {
                            if (rdo_Forward_W.Checked == true)
                            {
                                DMC_1.command("PA,,," + txt_PRPA_W.Text);
                            }
                            else if (rdo_Reverse_W.Checked == true)
                            {
                                DMC_1.command("PA,,,-" + txt_PRPA_W.Text);
                            }
                        }
                        else if (rdo_PR_W.Checked == true)
                        {
                            if (rdo_Forward_W.Checked == true)
                            {
                                DMC_1.command("PR,,," + txt_PRPA_W.Text);
                            }
                            else if (rdo_Reverse_W.Checked == true)
                            {
                                DMC_1.command("PR,,,-" + txt_PRPA_W.Text);
                            }
                        }
                        DMC_1.command("SP,,," + txt_SP_W.Text);
                        DMC_1.command("AC,,," + txt_AC_W.Text);
                        DMC_1.command("DC,,," + txt_DC_W.Text);
                        DMC_1.command("BGD");
                    }
                    else
                    {
                        MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        #endregion

        #region 穩速運動

        private void btn_JGA_X_Click(object sender, EventArgs e)
        {
            if (txt_JG_X.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_X.Text) * 5);

                try
                {
                    DMC_1.command("JG" + txt_JG_X.Text);
                    DMC_1.command("AC" + _ACDC);
                    DMC_1.command("DC" + _ACDC);
                    DMC_1.command("BGA");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGD_X_Click(object sender, EventArgs e)
        {
            if (txt_JG_X.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_X.Text) * 5);
                try
                {
                    DMC_1.command("JG-" + txt_JG_X.Text);
                    DMC_1.command("AC" + _ACDC);
                    DMC_1.command("DC" + _ACDC);
                    DMC_1.command("BGA");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGA_Y_Click(object sender, EventArgs e)
        {
            if (txt_JG_Y.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_Y.Text) * 5);
                try
                {
                    DMC_1.command("JG," + txt_JG_Y.Text);
                    DMC_1.command("AC," + _ACDC);
                    DMC_1.command("DC," + _ACDC);
                    DMC_1.command("BGB");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGD_Y_Click(object sender, EventArgs e)
        {
            if (txt_JG_Y.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_Y.Text) * 5);
                try
                {
                    DMC_1.command("JG,-" + txt_JG_Y.Text);
                    DMC_1.command("AC," + _ACDC);
                    DMC_1.command("DC," + _ACDC);
                    DMC_1.command("BGB");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGA_Z_Click(object sender, EventArgs e)
        {
            if (txt_JG_Z.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_Z.Text) * 5);
                try
                {
                    DMC_1.command("JG,," + txt_JG_Z.Text);
                    DMC_1.command("AC,," + _ACDC);
                    DMC_1.command("DC,," + _ACDC);
                    DMC_1.command("BGC");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGD_Z_Click(object sender, EventArgs e)
        {
            if (txt_JG_Z.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_Z.Text) * 5);
                try
                {
                    DMC_1.command("JG,,-" + txt_JG_Z.Text);
                    DMC_1.command("AC,," + _ACDC);
                    DMC_1.command("DC,," + _ACDC);
                    DMC_1.command("BGC");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGA_W_Click(object sender, EventArgs e)
        {
            if (txt_JG_W.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_W.Text) * 5);
                try
                {
                    DMC_1.command("JG,,," + txt_JG_W.Text);
                    DMC_1.command("AC,,," + _ACDC);
                    DMC_1.command("DC,,," + _ACDC);
                    DMC_1.command("BGD");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_JGD_W_Click(object sender, EventArgs e)
        {
            if (txt_JG_W.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                int _ACDC = (Convert.ToInt32(txt_JG_W.Text) * 5);
                try
                {
                    DMC_1.command("JG,,,-" + txt_JG_W.Text);
                    DMC_1.command("AC,,," + _ACDC);
                    DMC_1.command("DC,,," + _ACDC);
                    DMC_1.command("BGD");
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        #endregion

        #region 馬達 On/Off

        void MotorStatus()
        {
            int V1 = Convert.ToInt32(DMC_1.command(string.Format("TS{0}", "A")));
            int V2 = Convert.ToInt32(DMC_1.command(string.Format("TS{0}", "B")));
            int V3 = Convert.ToInt32(DMC_1.command(string.Format("TS{0}", "C")));
            int V4 = Convert.ToInt32(DMC_1.command(string.Format("TS{0}", "D")));

            if ((V1 & 32) < 1)
            {
                chk_X.Checked = true;
            }
            else
            {
                chk_X.Checked = false;
                btn_JGA_X.Enabled = false;
                btn_JGD_X.Enabled = false;
                rdo_Find_X.Enabled = false;
                rdo_Find_X.Checked = false;
                rdo_Loop_X.Enabled = false;
                rdo_Loop_X.Checked = false;
                gbx_X.Enabled = false;
            }
            if ((V2 & 32) < 1)
            {
                chk_Y.Checked = true;
            }
            else
            {
                chk_Y.Checked = false;
                btn_JGA_Y.Enabled = false;
                btn_JGD_Y.Enabled = false;
                rdo_Find_Y.Enabled = false;
                rdo_Find_Y.Checked = false;
                rdo_Loop_Y.Enabled = false;
                rdo_Loop_Y.Checked = false;
                gbx_Y.Enabled = false;
            }
            if ((V3 & 32) < 1)
            {
                chk_Z.Checked = true;
            }
            else
            {
                chk_Z.Checked = false;
                btn_JGA_Z.Enabled = false;
                btn_JGD_Z.Enabled = false;
                rdo_Find_Z.Enabled = false;
                rdo_Find_Z.Checked = false;
                rdo_Loop_Z.Enabled = false;
                rdo_Loop_Z.Checked = false;
                gbx_Z.Enabled = false;
            }
            if ((V4 & 32) < 1)
            {
                chk_W.Checked = true;
            }
            else
            {
                chk_W.Checked = false;
                btn_JGA_W.Enabled = false;
                btn_JGD_W.Enabled = false;
                rdo_Find_W.Enabled = false;
                rdo_Find_W.Checked = false;
                rdo_Loop_W.Enabled = false;
                rdo_Loop_W.Checked = false;
                gbx_W.Enabled = false;
            }
        }

        private void chk_X_Click(object sender, EventArgs e)
        {
            try
            {
                if (pnl_MotionStatus_X.BackColor == Color.Red)
                {
                    chk_X.Checked = true;
                    MessageBox.Show("馬達運行中!!");
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }
        private void chk_Y_Click(object sender, EventArgs e)
        {
            try
            {
                if (pnl_MotionStatus_Y.BackColor == Color.Red)
                {
                    chk_Y.Checked = true;
                    MessageBox.Show("馬達運行中!!");
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }
        private void chk_Z_Click(object sender, EventArgs e)
        {
            try
            {
                if (pnl_MotionStatus_Z.BackColor == Color.Red)
                {
                    chk_Z.Checked = true;
                    MessageBox.Show("馬達運行中!!");
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }
        private void chk_W_Click(object sender, EventArgs e)
        {
            try
            {
                if (pnl_MotionStatus_W.BackColor == Color.Red)
                {
                    chk_W.Checked = true;
                    MessageBox.Show("馬達運行中!!");
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_X_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_X.Checked == true)
                {
                    DMC_1.command("SHA");
                    btn_JGA_X.Enabled = true;
                    btn_JGD_X.Enabled = true;
                    rdo_Find_X.Enabled = true;
                    rdo_Loop_X.Enabled = true;
                    gbx_X.Enabled = true;
                }
                else
                {
                    DMC_1.command("MOA");
                    btn_JGA_X.Enabled = false;
                    btn_JGD_X.Enabled = false;
                    rdo_Find_X.Enabled = false;
                    rdo_Find_X.Checked = false;
                    rdo_Loop_X.Enabled = false;
                    rdo_Loop_X.Checked = false;
                    gbx_X.Enabled = false;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_Y_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_Y.Checked == true)
                {
                    DMC_1.command("SHB");
                    btn_JGA_Y.Enabled = true;
                    btn_JGD_Y.Enabled = true;
                    rdo_Find_Y.Enabled = true;
                    rdo_Loop_Y.Enabled = true;
                    gbx_Y.Enabled = true;
                }
                else
                {
                    DMC_1.command("MOB");
                    btn_JGA_Y.Enabled = false;
                    btn_JGD_Y.Enabled = false;
                    rdo_Find_Y.Enabled = false;
                    rdo_Find_Y.Checked = false;
                    rdo_Loop_Y.Enabled = false;
                    rdo_Loop_Y.Checked = false;
                    gbx_Y.Enabled = false;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_Z_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_Z.Checked == true)
                {
                    DMC_1.command("SHC");
                    btn_JGA_Z.Enabled = true;
                    btn_JGD_Z.Enabled = true;
                    rdo_Find_Z.Enabled = true;
                    rdo_Loop_Z.Enabled = true;
                    gbx_Z.Enabled = true;
                }
                else
                {
                    DMC_1.command("MOC");
                    btn_JGA_Z.Enabled = false;
                    btn_JGD_Z.Enabled = false;
                    rdo_Find_Z.Enabled = false;
                    rdo_Find_Z.Checked = false;
                    rdo_Loop_Z.Enabled = false;
                    rdo_Loop_Z.Checked = false;
                    gbx_Z.Enabled = false;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_W_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_W.Checked == true)
                {
                    DMC_1.command("SHD");
                    btn_JGA_W.Enabled = true;
                    btn_JGD_W.Enabled = true;
                    rdo_Find_W.Enabled = true;
                    rdo_Loop_W.Enabled = true;
                    gbx_W.Enabled = true;
                }
                else
                {
                    DMC_1.command("MOD");
                    btn_JGA_W.Enabled = false;
                    btn_JGD_W.Enabled = false;
                    rdo_Find_W.Enabled = false;
                    rdo_Find_W.Checked = false;
                    rdo_Loop_W.Enabled = false;
                    rdo_Loop_W.Checked = false;
                    gbx_W.Enabled = false;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        #endregion

        #region 找原點

        private void btn_FEA_Click(object sender, EventArgs e)
        {
            if (txt_FE_SP.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    DMC_1.command("CN,1");
                    if (rdo_Find_X.Checked == true)
                    {
                        DMC_1.command("JG" + txt_FE_SP.Text);
                        DMC_1.command("FEA");
                        DMC_1.command("BGA");
                    }
                    else if (rdo_Find_Y.Checked == true)
                    {
                        DMC_1.command("JG," + txt_FE_SP.Text);
                        DMC_1.command("FEB");
                        DMC_1.command("BGB");
                    }
                    else if (rdo_Find_Z.Checked == true)
                    {
                        DMC_1.command("JG,," + txt_FE_SP.Text);
                        DMC_1.command("FEC");
                        DMC_1.command("BGC");
                    }
                    else if (rdo_Find_W.Checked == true)
                    {
                        DMC_1.command("JG,,," + txt_FE_SP.Text);
                        DMC_1.command("FED");
                        DMC_1.command("BGD");
                    }
                    else
                    {
                        MessageBox.Show("請選擇一軸");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_FED_Click(object sender, EventArgs e)
        {
            if (txt_FE_SP.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    DMC_1.command("CN,-1");
                    if (rdo_Find_X.Checked == true)
                    {
                        DMC_1.command("JG" + txt_FE_SP.Text);
                        DMC_1.command("FEA");
                        DMC_1.command("BGA");
                    }
                    else if (rdo_Find_Y.Checked == true)
                    {
                        DMC_1.command("JG," + txt_FE_SP.Text);
                        DMC_1.command("FEB");
                        DMC_1.command("BGB");
                    }
                    else if (rdo_Find_Z.Checked == true)
                    {
                        DMC_1.command("JG,," + txt_FE_SP.Text);
                        DMC_1.command("FEC");
                        DMC_1.command("BGC");
                    }
                    else if (rdo_Find_W.Checked == true)
                    {
                        DMC_1.command("JG,,," + txt_FE_SP.Text);
                        DMC_1.command("FED");
                        DMC_1.command("BGD");
                    }
                    else
                    {
                        MessageBox.Show("請選擇一軸");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_FIA_Click(object sender, EventArgs e)
        {
            if (txt_FI_SP.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (rdo_Find_X.Checked == true)
                    {
                        DMC_1.command("JG" + txt_FI_SP.Text);
                        DMC_1.command("FIA");
                        DMC_1.command("BGA");
                    }
                    else if (rdo_Find_Y.Checked == true)
                    {
                        DMC_1.command("JG," + txt_FI_SP.Text);
                        DMC_1.command("FIB");
                        DMC_1.command("BGB");
                    }
                    else if (rdo_Find_Z.Checked == true)
                    {
                        DMC_1.command("JG,," + txt_FI_SP.Text);
                        DMC_1.command("FIC");
                        DMC_1.command("BGC");
                    }
                    else if (rdo_Find_W.Checked == true)
                    {
                        DMC_1.command("JG,,," + txt_FI_SP.Text);
                        DMC_1.command("FID");
                        DMC_1.command("BGD");
                    }
                    else
                    {
                        MessageBox.Show("請選擇一軸");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void btn_FID_Click(object sender, EventArgs e)
        {
            if (txt_FI_SP.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    if (rdo_Find_X.Checked == true)
                    {
                        DMC_1.command("JG-" + txt_FI_SP.Text);
                        DMC_1.command("FIA");
                        DMC_1.command("BGA");
                    }
                    else if (rdo_Find_Y.Checked == true)
                    {
                        DMC_1.command("JG,-" + txt_FI_SP.Text);
                        DMC_1.command("FIB");
                        DMC_1.command("BGB");
                    }
                    else if (rdo_Find_Z.Checked == true)
                    {
                        DMC_1.command("JG,,-" + txt_FI_SP.Text);
                        DMC_1.command("FIC");
                        DMC_1.command("BGC");
                    }
                    else if (rdo_Find_W.Checked == true)
                    {
                        DMC_1.command("JG,,,-" + txt_FI_SP.Text);
                        DMC_1.command("FID");
                        DMC_1.command("BGD");
                    }
                    else
                    {
                        MessageBox.Show("請選擇一軸");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        #endregion

        #region 迴圈運動

        private void btn_LoopForward_Click(object sender, EventArgs e)
        {
            if (txt_Loop_PR.Text == "" || txt_Loop_PA1.Text == "" || txt_Loop_PA2.Text == "" || txt_Loop_SP.Text == "" || txt_Loop_AC.Text == "" || txt_Loop_DC.Text == "" || txt_waittime.Text == "")
            {
                MessageBox.Show("欄位不能為空。");
            }
            else
            {
                try
                {
                    int Loop = Convert.ToInt32(num_LoopCount.Value);

                    if (rdo_Loop_X.Checked == true)
                    {
                        if (pnl_MotionStatus_X.BackColor == Color.LawnGreen)
                        {
                            if (rdo_Loop_PA.Checked == true)
                            {
                                #region PA

                                string Programm_PA = string.Empty;
                                Programm_PA += "#Program_PA;\r\n";
                                Programm_PA += string.Format("M={0};\r\n", Loop);

                                Programm_PA += "#LOOP;\r\n";

                                if (rdo_LoopForward_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA{0};\r\n", txt_Loop_PA1.Text);
                                }
                                else if (rdo_LoopReverse_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA-{0};\r\n", txt_Loop_PA1.Text);
                                }

                                Programm_PA += string.Format("SP{0};\r\n", txt_Loop_SP.Text);
                                Programm_PA += string.Format("AC{0};\r\n", txt_Loop_AC.Text);
                                Programm_PA += string.Format("DC{0};\r\n", txt_Loop_DC.Text);

                                Programm_PA += "BGA;\r\n";
                                Programm_PA += "AMA;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PA.Checked == true)
                                {
                                    if (rdo_LoopForward_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                    else if (rdo_LoopReverse_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA-{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                }

                                Programm_PA += "BGA;\r\n";
                                Programm_PA += "AMA;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);

                                //if (rdo_Loop_PA.Checked == true)
                                //{
                                //    if (rdo_LoopForward_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    else if (rdo_LoopReverse_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA-{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    Programm_PA += "BGA;\r\n";
                                //    Programm_PA += "AMA;\r\n";
                                //    Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);
                                //}

                                Programm_PA += "M=M-1;\r\n";
                                Programm_PA += "JP#LOOP,M>0;\r\n";
                                Programm_PA += "EN;\r\n";
                                DMC_1.programDownload(Programm_PA);
                                DMC_1.command("XQ");

                                #endregion
                            }
                            else if (rdo_Loop_PR.Checked == true)
                            {
                                #region PR


                                string Programm_PR = string.Empty;
                                Programm_PR += "#Program_PR;\r\n";
                                Programm_PR += string.Format("M={0};\r\n", Loop);
                                Programm_PR += "#LOOP;\r\n";

                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += string.Format("SP{0};\r\n", txt_Loop_SP.Text);
                                Programm_PR += string.Format("AC{0};\r\n", txt_Loop_AC.Text);
                                Programm_PR += string.Format("DC{0};\r\n", txt_Loop_DC.Text);

                                Programm_PR += "BGA;\r\n";
                                Programm_PR += "AMA;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);

                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += "BGA;\r\n";
                                Programm_PR += "AMA;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);

                                Programm_PR += "M=M-1;\r\n";
                                Programm_PR += "JP#LOOP,M>0;\r\n";
                                Programm_PR += "EN;\r\n";
                                DMC_1.programDownload(Programm_PR);
                                DMC_1.command("XQ");

                                #endregion
                            }
                        }
                        else
                        {
                            MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                        }
                    }
                    else if (rdo_Loop_Y.Checked == true)
                    {
                        if (pnl_MotionStatus_Y.BackColor == Color.LawnGreen)
                        {
                            if (rdo_Loop_PA.Checked == true)
                            {
                                #region PA

                                string Programm_PA = string.Empty;
                                Programm_PA += "#Program_PA;\r\n";
                                Programm_PA += string.Format("M={0};\r\n", Loop);

                                Programm_PA += "#LOOP;\r\n";
                                if (rdo_LoopForward_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,{0};\r\n", txt_Loop_PA1.Text);
                                }
                                else if (rdo_LoopReverse_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,-{0};\r\n", txt_Loop_PA1.Text);
                                }


                                Programm_PA += string.Format("SP,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PA += string.Format("AC,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PA += string.Format("DC,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PA += "BGB;\r\n";
                                Programm_PA += "AMB;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PA.Checked == true)
                                {
                                    if (rdo_LoopForward_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                    else if (rdo_LoopReverse_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,-{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                }


                                Programm_PA += "BGB;\r\n";
                                Programm_PA += "AMB;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);

                                //if (rdo_Loop_PA.Checked == true)
                                //{
                                //    if (rdo_LoopForward_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    else if (rdo_LoopReverse_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,-{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    Programm_PA += "BGB;\r\n";
                                //    Programm_PA += "AMB;\r\n";
                                //    Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);
                                //}

                                Programm_PA += "M=M-1;\r\n";
                                Programm_PA += "JP#LOOP,M>0;\r\n";
                                Programm_PA += "EN;\r\n";
                                DMC_1.programDownload(Programm_PA);
                                DMC_1.command("XQ");

                                #endregion
                            }
                            else if (rdo_Loop_PR.Checked == true)
                            {
                                #region PR

                                string Programm_PR = string.Empty;
                                Programm_PR += "#Program_PR;\r\n";
                                Programm_PR += string.Format("M={0};\r\n", Loop);
                                Programm_PR += "#LOOP;\r\n";


                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += string.Format("SP,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PR += string.Format("AC,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PR += string.Format("DC,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PR += "BGB;\r\n";
                                Programm_PR += "AMB;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += "BGB;\r\n";
                                Programm_PR += "AMB;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);



                                Programm_PR += "M=M-1;\r\n";
                                Programm_PR += "JP#LOOP,M>0;\r\n";
                                Programm_PR += "EN;\r\n";
                                DMC_1.programDownload(Programm_PR);
                                DMC_1.command("XQ");


                                #endregion
                            }
                        }
                        else
                        {
                            MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                        }
                    }
                    else if (rdo_Loop_Z.Checked == true)
                    {
                        if (pnl_MotionStatus_Z.BackColor == Color.LawnGreen)
                        {
                            if (rdo_Loop_PA.Checked == true)
                            {
                                #region PA

                                string Programm_PA = string.Empty;
                                Programm_PA += "#Program_PA;\r\n";
                                Programm_PA += string.Format("M={0};\r\n", Loop);


                                Programm_PA += "#LOOP;\r\n";
                                if (rdo_LoopForward_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,,{0};\r\n", txt_Loop_PA1.Text);
                                }
                                else if (rdo_LoopReverse_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,,-{0};\r\n", txt_Loop_PA1.Text);
                                }


                                Programm_PA += string.Format("SP,,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PA += string.Format("AC,,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PA += string.Format("DC,,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PA += "BGC;\r\n";
                                Programm_PA += "AMC;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PA.Checked == true)
                                {
                                    if (rdo_LoopForward_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,,{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                    else if (rdo_LoopReverse_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,,-{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                }


                                Programm_PA += "BGC;\r\n";
                                Programm_PA += "AMC;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);

                                //if (rdo_Loop_PA.Checked == true)
                                //{
                                //    if (rdo_LoopForward_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,,{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    else if (rdo_LoopReverse_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,,-{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    Programm_PA += "BGC;\r\n";
                                //    Programm_PA += "AMC;\r\n";
                                //    Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);
                                //}

                                Programm_PA += "M=M-1;\r\n";
                                Programm_PA += "JP#LOOP,M>0;\r\n";
                                Programm_PA += "EN;\r\n";
                                DMC_1.programDownload(Programm_PA);
                                DMC_1.command("XQ");

                                #endregion
                            }
                            else if (rdo_Loop_PR.Checked == true)
                            {
                                #region PR

                                string Programm_PR = string.Empty;
                                Programm_PR += "#Program_PR;\r\n";
                                Programm_PR += string.Format("M={0};\r\n", Loop);
                                Programm_PR += "#LOOP;\r\n";


                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += string.Format("SP,,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PR += string.Format("AC,,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PR += string.Format("DC,,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PR += "BGC;\r\n";
                                Programm_PR += "AMC;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += "BGC;\r\n";
                                Programm_PR += "AMC;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);

                                Programm_PR += "M=M-1;\r\n";
                                Programm_PR += "JP#LOOP,M>0;\r\n";
                                Programm_PR += "EN;\r\n";
                                DMC_1.programDownload(Programm_PR);
                                DMC_1.command("XQ");

                                #endregion
                            }
                        }
                        else
                        {
                            MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                        }
                    }
                    else if (rdo_Loop_W.Checked == true)
                    {
                        if (pnl_MotionStatus_W.BackColor == Color.LawnGreen)
                        {
                            if (rdo_Loop_PA.Checked == true)
                            {
                                #region PA

                                string Programm_PA = string.Empty;
                                Programm_PA += "#Program_PA;\r\n";
                                Programm_PA += string.Format("M={0};\r\n", Loop);


                                Programm_PA += "#LOOP;\r\n";
                                if (rdo_LoopForward_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,,,{0};\r\n", txt_Loop_PA1.Text);
                                }
                                else if (rdo_LoopReverse_PA1.Checked == true)
                                {
                                    Programm_PA += string.Format("PA,,,-{0};\r\n", txt_Loop_PA1.Text);
                                }


                                Programm_PA += string.Format("SP,,,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PA += string.Format("AC,,,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PA += string.Format("DC,,,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PA += "BGD;\r\n";
                                Programm_PA += "AMD;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PA.Checked == true)
                                {
                                    if (rdo_LoopForward_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,,,{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                    else if (rdo_LoopReverse_PA2.Checked == true)
                                    {
                                        Programm_PA += string.Format("PA,,,-{0};\r\n", txt_Loop_PA2.Text);
                                    }
                                }

                                Programm_PA += "BGD;\r\n";
                                Programm_PA += "AMD;\r\n";
                                Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);

                                //if (rdo_Loop_PA.Checked == true)
                                //{
                                //    if (rdo_LoopForward_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,,,{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    else if (rdo_LoopReverse_PA1.Checked == true)
                                //    {
                                //        Programm_PA += string.Format("PA,,,-{0};\r\n", txt_Loop_PA1.Text);
                                //    }
                                //    Programm_PA += "BGD;\r\n";
                                //    Programm_PA += "AMD;\r\n";
                                //    Programm_PA += string.Format("WT{0};\r\n", txt_waittime.Text);
                                //}

                                Programm_PA += "M=M-1;\r\n";
                                Programm_PA += "JP#LOOP,M>0;\r\n";
                                Programm_PA += "EN;\r\n";
                                DMC_1.programDownload(Programm_PA);
                                DMC_1.command("XQ");

                                #endregion
                            }
                            else if (rdo_Loop_PR.Checked == true)
                            {
                                #region PR

                                string Programm_PR = string.Empty;
                                Programm_PR += "#Program_PR;\r\n";
                                Programm_PR += string.Format("M={0};\r\n", Loop);
                                Programm_PR += "#LOOP;\r\n";

                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += string.Format("SP,,,{0};\r\n", txt_Loop_SP.Text);
                                Programm_PR += string.Format("AC,,,{0};\r\n", txt_Loop_AC.Text);
                                Programm_PR += string.Format("DC,,,{0};\r\n", txt_Loop_DC.Text);

                                Programm_PR += "BGD;\r\n";
                                Programm_PR += "AMD;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);


                                if (rdo_Loop_PR.Checked == true)
                                {
                                    if (rdo_LoopForward_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,,-{0};\r\n", txt_Loop_PR.Text);
                                    }
                                    else if (rdo_LoopReverse_PR.Checked == true)
                                    {
                                        Programm_PR += string.Format("PR,,,{0};\r\n", txt_Loop_PR.Text);
                                    }
                                }

                                Programm_PR += "BGD;\r\n";
                                Programm_PR += "AMD;\r\n";
                                Programm_PR += string.Format("WT{0};\r\n", txt_waittime.Text);

                                Programm_PR += "M=M-1;\r\n";
                                Programm_PR += "JP#LOOP,M>0;\r\n";
                                Programm_PR += "EN;\r\n";
                                DMC_1.programDownload(Programm_PR);
                                DMC_1.command("XQ");

                                #endregion
                            }
                        }
                        else
                        {
                            MessageBox.Show("馬達運行中，請等待或停止後在進行下一次動作。");
                        }
                    }
                    else
                    {
                        MessageBox.Show("請選擇一軸");
                    }
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        private void rdo_Loop_PR_CheckedChanged(object sender, EventArgs e)
        {
            pnl_Loop_PR.Visible = true;
            pnl_Loop_PA1.Visible = false;
            pnl_Loop_PA2.Visible = false;
        }

        private void rdo_Loop_PA_CheckedChanged(object sender, EventArgs e)
        {
            pnl_Loop_PR.Visible = false;
            pnl_Loop_PA1.Visible = true;
            pnl_Loop_PA2.Visible = true;
        }
        
        #endregion

        #region 位置歸零

        private void btn_DP0_X_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("DPA=0");
                DMC_1.command("DEA=0");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_DP0_Y_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("DPB=0");
                DMC_1.command("DEB=0");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_DP0_Z_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("DPC=0");
                DMC_1.command("DEC=0");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_DP0_W_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("DPD=0");
                DMC_1.command("DED=0");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        #endregion

        #region 進階操作/DL/UL/XQ

        private void btn_XQ_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("XQ");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_DL_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.programDownload(rtx_Program.Text);
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void btn_UL_Click(object sender, EventArgs e)
        {
            try
            {
                rtx_Program.Text = DMC_1.programUpload();
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        //Clear Code
        private void btn_txtPro_Clear_Click(object sender, EventArgs e)
        {
            rtx_Program.Clear();
        }

        private void btn_LoadProgram_Click(object sender, EventArgs e)
        {
            openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "*.txt|*.txt";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    using (StreamReader sr = new StreamReader(openFileDialog1.FileName, Encoding.Default))

                    //加入(file,Encoding.Default)  解決中文亂碼問題
                    {
                        String line;
                        string text = "";
                        while ((line = sr.ReadLine()) != null)
                        {
                            text += line + "\n";
                        }
                        rtx_Program.Text = text;
                    }
                }
                catch
                {
                    MessageBox.Show("讀取失敗。");
                }
            }
        }

        private void btn_SaveProgram_Click(object sender, EventArgs e)
        {
            saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter = "*.txt|*.txt";
            saveFileDialog1.AddExtension = true;

            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                rtx_Program.SaveFile(saveFileDialog1.FileName, RichTextBoxStreamType.PlainText);
            }
        }

        #endregion

        #region menuStrip

        private void mns_Connect_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.address = " ";
                this.Text = string.Format("GalilTools [ver 1.0.0] {0}", DMC_1.connection());
                DMC_1.command("MO");              
                MotorStatus();
                G_StatusCheck_Tick();              
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                MessageBox.Show("連線失敗，請檢查連線。");                
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void mns_Offline_Click(object sender, EventArgs e)
        {
            try
            {
                G_thStatusChk.Abort();
                this.Text = string.Format("GalilTools [ver 1.0.0]" + "  離線");                
                DMC_1.address = "OFFLINE";
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void mns_About_Click(object sender, EventArgs e)
        {
            new Frm_About().Show();
        }

        private void mns_Exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        #endregion

        #region Set Outputs

        private void chk_OP1_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP1.Checked == true)
                {
                    DMC_1.command("SB1");
                    osp_OP1.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB1");
                    osp_OP1.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP2_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP2.Checked == true)
                {
                    DMC_1.command("SB2");
                    osp_OP2.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB2");
                    osp_OP2.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP3_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP3.Checked == true)
                {
                    DMC_1.command("SB3");
                    osp_OP3.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB3");
                    osp_OP3.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP4_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP4.Checked == true)
                {
                    DMC_1.command("SB4");
                    osp_OP4.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB4");
                    osp_OP4.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP5_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP5.Checked == true)
                {
                    DMC_1.command("SB5");
                    osp_OP5.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB5");
                    osp_OP5.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP6_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP6.Checked == true)
                {
                    DMC_1.command("SB6");
                    osp_OP6.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB6");
                    osp_OP6.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP7_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP7.Checked == true)
                {
                    DMC_1.command("SB7");
                    osp_OP7.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB7");
                    osp_OP7.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        private void chk_OP8_CheckedChanged(object sender, EventArgs e)
        {
            try
            {
                if (chk_OP8.Checked == true)
                {
                    DMC_1.command("SB8");
                    osp_OP8.FillColor = Color.Yellow;
                }
                else
                {
                    DMC_1.command("CB8");
                    osp_OP8.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        #endregion

        #region 狀態查詢

        delegate void dStatus();
        private void Status()
        {
            txt_RPX.Text = RPA;
            txt_RPY.Text = RPB;
            txt_RPZ.Text = RPC;
            txt_RPW.Text = RPD;
            txt_TPX.Text = TPA;
            txt_TPY.Text = TPB;
            txt_TPZ.Text = TPC;
            txt_TPW.Text = TPD;

            //X軸狀態顯示
            lab_MotionStatus_X.Text = Motion_X;
            pnl_MotionStatus_X.BackColor = MotionColor_X;
            txt_MotorStatus_X.Text = Motor_X;
            txt_MotorStatus_X.BackColor = MotorColor_X;
            if (MotorColor_X == Color.LawnGreen)
            {
                chk_X.Checked = false;
            }
            else
            {
                chk_X.Checked = true;
            }
            osp_Forward_X.FillColor = Forward_X;
            osp_Home_X.FillColor = Home_X;
            osp_Reverse_X.FillColor = Reverse_X;

            //Y軸狀態顯示
            lab_MotionStatus_Y.Text = Motion_Y;
            pnl_MotionStatus_Y.BackColor = MotionColor_Y;
            txt_MotorStatus_Y.Text = Motor_Y;
            txt_MotorStatus_Y.BackColor = MotorColor_Y;
            if (MotorColor_Y == Color.LawnGreen)
            {
                chk_Y.Checked = false;
            }
            else
            {
                chk_Y.Checked = true;
            }
            osp_Forward_Y.FillColor = Forward_Y;
            osp_Home_Y.FillColor = Home_Y;
            osp_Reverse_Y.FillColor = Reverse_Y;

            //Z軸狀態顯示
            lab_MotionStatus_Z.Text = Motion_Z;
            pnl_MotionStatus_Z.BackColor = MotionColor_Z;
            txt_MotorStatus_Z.Text = Motor_Z;
            txt_MotorStatus_Z.BackColor = MotorColor_Z;
            if (MotorColor_Z == Color.LawnGreen)
            {
                chk_Z.Checked = false;
            }
            else
            {
                chk_Z.Checked = true;
            }
            osp_Forward_Z.FillColor = Forward_Z;
            osp_Home_Z.FillColor = Home_Z;
            osp_Reverse_Z.FillColor = Reverse_Z;

            //W軸狀態顯示
            lab_MotionStatus_W.Text = Motion_W;
            pnl_MotionStatus_W.BackColor = MotionColor_W;
            txt_MotorStatus_W.Text = Motor_W;
            txt_MotorStatus_W.BackColor = MotorColor_W;
            if (MotorColor_W == Color.LawnGreen)
            {
                chk_W.Checked = false;
            }
            else
            {
                chk_W.Checked = true;
            }
            osp_Forward_W.FillColor = Forward_W;
            osp_Home_W.FillColor = Home_W;
            osp_Reverse_W.FillColor = Reverse_W;
        }

        void TellRPTP()
        {
            RPA = DMC_1.command("RPA");
            RPB = DMC_1.command("RPB");
            RPC = DMC_1.command("RPC");
            RPD = DMC_1.command("RPD");

            TPA = DMC_1.command("TPA");
            TPB = DMC_1.command("TPB");
            TPC = DMC_1.command("TPC");
            TPD = DMC_1.command("TPD");
        }

        private void TellSwitches(string Axis, out string Motion, out Color MotionColor, out string Motor, out Color MotorColor, out Color Forward, out Color Reverse, out Color Home)
        {
            int V1 = Convert.ToInt32(DMC_1.command(string.Format("TS{0}", Axis)));
            Motion = string.Empty;
            Motor = string.Empty;
            Forward = Color.Empty;
            Reverse = Color.Empty;
            Home = Color.Empty;

            if ((V1 & 128) > 0)
            {
                MotionColor = Color.Red;
                Motion = "運轉中";
            }
            else
            {
                MotionColor = Color.LawnGreen;
                Motion = "待機中";
            }
            if ((V1 & 32) > 0)
            {
                Motor = "Off";
                MotorColor = Color.LawnGreen;
            }
            else
            {
                Motor = "On";
                MotorColor = Color.Red;
            }
            if ((V1 & 8) > 0)
            {
                Forward = Color.Transparent;
            }
            else
            {
                Forward = Color.Yellow;
            }
            if ((V1 & 4) > 0)
            {
                Reverse = Color.Transparent;
            }
            else
            {
                Reverse = Color.Yellow;
            }
            if ((V1 & 2) > 0)
            {
                Home = Color.Transparent;
            }
            else
            {
                Home = Color.Yellow;
            }
        }

        delegate void dTell_Inputs();
        private void Tell_Inputs()
        {
            try
            {
                int TI = Convert.ToInt32(DMC_1.command("TI"));

                if ((TI & 128) > 0)
                {
                    osp_TI8.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI8.FillColor = Color.Transparent;
                }
                if ((TI & 64) > 0)
                {
                    osp_TI7.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI7.FillColor = Color.Transparent;
                }
                if ((TI & 32) > 0)
                {
                    osp_TI6.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI6.FillColor = Color.Transparent;
                }
                if ((TI & 16) > 0)
                {
                    osp_TI5.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI5.FillColor = Color.Transparent;
                }
                if ((TI & 8) > 0)
                {
                    osp_TI4.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI4.FillColor = Color.Transparent;
                }
                if ((TI & 4) > 0)
                {
                    osp_TI3.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI3.FillColor = Color.Transparent;
                }
                if ((TI & 2) > 0)
                {
                    osp_TI2.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI2.FillColor = Color.Transparent;
                }
                if ((TI & 1) > 0)
                {
                    osp_TI1.FillColor = Color.Yellow;
                }
                else
                {
                    osp_TI1.FillColor = Color.Transparent;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        delegate void dTell_Outputs();
        private void Tell_Outputs()
        {
            try
            {
                int OP = Convert.ToInt32(DMC_1.commandValue("MG_OP"));

                if ((OP & 1) > 0)
                {
                    osp_OP1.FillColor = Color.Yellow;
                    chk_OP1.Checked = true;
                }
                else
                {
                    osp_OP1.FillColor = Color.Transparent;
                    chk_OP1.Checked = false;
                }
                if ((OP & 2) > 0)
                {
                    osp_OP2.FillColor = Color.Yellow;
                    chk_OP2.Checked = true;
                }
                else
                {
                    osp_OP2.FillColor = Color.Transparent;
                    chk_OP2.Checked = false;
                }
                if ((OP & 4) > 0)
                {
                    osp_OP3.FillColor = Color.Yellow;
                    chk_OP3.Checked = true;
                }
                else
                {
                    osp_OP3.FillColor = Color.Transparent;
                    chk_OP3.Checked = false;
                }
                if ((OP & 8) > 0)
                {
                    osp_OP4.FillColor = Color.Yellow;
                    chk_OP4.Checked = true;
                }
                else
                {
                    osp_OP4.FillColor = Color.Transparent;
                    chk_OP4.Checked = false;
                }
                if ((OP & 16) > 0)
                {
                    osp_OP5.FillColor = Color.Yellow;
                    chk_OP5.Checked = true;
                }
                else
                {
                    osp_OP5.FillColor = Color.Transparent;
                    chk_OP5.Checked = false;
                }
                if ((OP & 32) > 0)
                {
                    osp_OP6.FillColor = Color.Yellow;
                    chk_OP6.Checked = true;
                }
                else
                {
                    osp_OP6.FillColor = Color.Transparent;
                    chk_OP6.Checked = false;
                }
                if ((OP & 64) > 0)
                {
                    osp_OP7.FillColor = Color.Yellow;
                    chk_OP7.Checked = true;
                }
                else
                {
                    osp_OP7.FillColor = Color.Transparent;
                    chk_OP7.Checked = false;
                }
                if ((OP & 128) > 0)
                {
                    osp_OP8.FillColor = Color.Yellow;
                    chk_OP8.Checked = true;
                }
                else
                {
                    osp_OP8.FillColor = Color.Transparent;
                    chk_OP8.Checked = false;
                }
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }

        delegate void dStopCode();
        private void StopCode()
        {
            int SC_X = Convert.ToInt32(DMC_1.command("SCA"));
            int SC_Y = Convert.ToInt32(DMC_1.command("SCB"));
            int SC_Z = Convert.ToInt32(DMC_1.command("SCC"));
            int SC_W = Convert.ToInt32(DMC_1.command("SCD"));

            GalilTools.Reference.StopCode(SC_X, out StopCode_X);
            GalilTools.Reference.StopCode(SC_Y, out StopCode_Y);
            GalilTools.Reference.StopCode(SC_Z, out StopCode_Z);
            GalilTools.Reference.StopCode(SC_W, out StopCode_W);

            txt_StopCode_X.Text = StopCode_X;
            txt_StopCode_Y.Text = StopCode_Y;
            txt_StopCode_Z.Text = StopCode_Z;
            txt_StopCode_W.Text = StopCode_W;
        }

        Thread G_thStatusChk;

        private void G_StatusCheck_Tick()
        {
            G_thStatusChk = new Thread(() =>
            {
            L1:
                {
                    try
                    {
                        TellRPTP();
                        TellSwitches("A", out Motion_X, out MotionColor_X, out Motor_X, out MotorColor_X, out Forward_X, out Reverse_X, out Home_X);
                        TellSwitches("B", out Motion_Y, out MotionColor_Y, out Motor_Y, out MotorColor_Y, out Forward_Y, out Reverse_Y, out Home_Y);
                        TellSwitches("C", out Motion_Z, out MotionColor_Z, out Motor_Z, out MotorColor_Z, out Forward_Z, out Reverse_Z, out Home_Z);
                        TellSwitches("D", out Motion_W, out MotionColor_W, out Motor_W, out MotorColor_W, out Forward_W, out Reverse_W, out Home_W);
                        this.Invoke(new dStatus(Status));
                        this.Invoke(new dTell_Inputs(Tell_Inputs));
                        this.Invoke(new dTell_Outputs(Tell_Outputs));
                        this.Invoke(new dStopCode(StopCode));
                    }
                    catch
                    {

                    }
                }
                Thread.Sleep(100);
                goto L1;
            });
            G_thStatusChk.IsBackground = true;
            G_thStatusChk.Priority = ThreadPriority.BelowNormal;
            G_thStatusChk.Start();
        }

        #endregion

        #region txt

        //限制 TextBox 只能輸入數字，並且不能使用快速鍵
        private void txt_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (Char.IsDigit(e.KeyChar) || Char.IsControl(e.KeyChar))
            {
                e.Handled = false;
            }
            else
            {
                e.Handled = true;
            }
        }
        //Enter觸發事件
        private void txt_Command_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                try
                {
                    txt_CommandReply.Text = DMC_1.command(txt_Command.Text);
                    txt_Command.Clear();
                }
                catch (System.Runtime.InteropServices.COMException ex)
                {
                    txt_ErrorCode.Text = ex.Message.Trim();
                }
            }
        }

        #endregion

        #region 讀寫設定檔

        private void mns_SaveSettings_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("是否儲存設定檔案?", "確認", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
            {
                saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.Filter = "*.ini|*.ini";
                saveFileDialog1.AddExtension = true;
            L1:
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    if (MyIniSave(saveFileDialog1.FileName) == true)
                    {
                        MessageBox.Show("存檔成功。");
                    }
                    else
                    {
                        MessageBox.Show("存檔失敗。");
                        goto L1;
                    }
                }
            }
        }

        private void mns_LoadSettings_Click(object sender, EventArgs e)
        {
            openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "*.ini|*.ini";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                if (MyIniRead(openFileDialog1.FileName) != true)
                {
                    MessageBox.Show("讀取設定檔失敗。");
                }
                else
                {
                    MessageBox.Show("讀取設定檔成功。");
                }
            }
        }

        public bool MyIniSave(string Path)
        {
            try
            {
                IniWriteValue("X軸位移設定", "距離", txt_PRPA_X.Text, Path);
                IniWriteValue("X軸位移設定", "速度", txt_SP_X.Text, Path);
                IniWriteValue("X軸位移設定", "加速度", txt_AC_X.Text, Path);
                IniWriteValue("X軸位移設定", "減速度", txt_DC_X.Text, Path);

                IniWriteValue("Y軸位移設定", "距離", txt_PRPA_Y.Text, Path);
                IniWriteValue("Y軸位移設定", "速度", txt_SP_Y.Text, Path);
                IniWriteValue("Y軸位移設定", "加速度", txt_AC_Y.Text, Path);
                IniWriteValue("Y軸位移設定", "減速度", txt_DC_Y.Text, Path);

                IniWriteValue("Z軸位移設定", "距離", txt_PRPA_Z.Text, Path);
                IniWriteValue("Z軸位移設定", "速度", txt_SP_Z.Text, Path);
                IniWriteValue("Z軸位移設定", "加速度", txt_AC_Z.Text, Path);
                IniWriteValue("Z軸位移設定", "減速度", txt_DC_Z.Text, Path);

                IniWriteValue("W軸位移設定", "距離", txt_PRPA_W.Text, Path);
                IniWriteValue("W軸位移設定", "速度", txt_SP_W.Text, Path);
                IniWriteValue("W軸位移設定", "加速度", txt_AC_W.Text, Path);
                IniWriteValue("W軸位移設定", "減速度", txt_DC_W.Text, Path);

                IniWriteValue("穩速運動", "X軸", txt_JG_X.Text, Path);
                IniWriteValue("穩速運動", "Y軸", txt_JG_Y.Text, Path);
                IniWriteValue("穩速運動", "Z軸", txt_JG_Z.Text, Path);
                IniWriteValue("穩速運動", "W軸", txt_JG_W.Text, Path);

                IniWriteValue("找原點", "FE速度", txt_FE_SP.Text, Path);
                IniWriteValue("找原點", "FI速度", txt_FI_SP.Text, Path);

                IniWriteValue("迴圈", "距離", txt_Loop_PR.Text, Path);
                IniWriteValue("迴圈", "位置1", txt_Loop_PA1.Text, Path);
                IniWriteValue("迴圈", "位置2", txt_Loop_PA2.Text, Path);
                IniWriteValue("迴圈", "速度", txt_Loop_SP.Text, Path);
                IniWriteValue("迴圈", "加速度", txt_Loop_AC.Text, Path);
                IniWriteValue("迴圈", "減速度", txt_Loop_DC.Text, Path);
                IniWriteValue("迴圈", "迴圈數", num_LoopCount.Value.ToString(), Path);
                IniWriteValue("迴圈", "等待時間", txt_waittime.Text, Path);

                return true;
            }
            catch
            {
                return false;
            }
        }

        public bool MyIniRead(string Path)
        {
            try
            {
                txt_PRPA_X.Text = string.Format(IniReadValue("X軸位移設定", "距離", Path));
                txt_SP_X.Text = string.Format(IniReadValue("X軸位移設定", "速度", Path));
                txt_AC_X.Text = string.Format(IniReadValue("X軸位移設定", "加速度", Path));
                txt_DC_X.Text = string.Format(IniReadValue("X軸位移設定", "減速度", Path));

                txt_PRPA_Y.Text = string.Format(IniReadValue("Y軸位移設定", "距離", Path));
                txt_SP_Y.Text = string.Format(IniReadValue("Y軸位移設定", "速度", Path));
                txt_AC_Y.Text = string.Format(IniReadValue("Y軸位移設定", "加速度", Path));
                txt_DC_Y.Text = string.Format(IniReadValue("Y軸位移設定", "減速度", Path));

                txt_PRPA_Z.Text = string.Format(IniReadValue("Z軸位移設定", "距離", Path));
                txt_SP_Z.Text = string.Format(IniReadValue("Z軸位移設定", "速度", Path));
                txt_AC_Z.Text = string.Format(IniReadValue("Z軸位移設定", "加速度", Path));
                txt_DC_Z.Text = string.Format(IniReadValue("Z軸位移設定", "減速度", Path));

                txt_PRPA_W.Text = string.Format(IniReadValue("W軸位移設定", "距離", Path));
                txt_SP_W.Text = string.Format(IniReadValue("W軸位移設定", "速度", Path));
                txt_AC_W.Text = string.Format(IniReadValue("W軸位移設定", "加速度", Path));
                txt_DC_W.Text = string.Format(IniReadValue("W軸位移設定", "減速度", Path));

                txt_JG_X.Text = string.Format(IniReadValue("穩速運動", "X軸", Path));
                txt_JG_Y.Text = string.Format(IniReadValue("穩速運動", "Y軸", Path));
                txt_JG_Z.Text = string.Format(IniReadValue("穩速運動", "Z軸", Path));
                txt_JG_W.Text = string.Format(IniReadValue("穩速運動", "W軸", Path));

                txt_FE_SP.Text = string.Format(IniReadValue("找原點", "FE速度", Path));
                txt_FI_SP.Text = string.Format(IniReadValue("找原點", "FI速度", Path));

                txt_Loop_PR.Text = string.Format(IniReadValue("迴圈", "距離", Path));
                txt_Loop_PA1.Text = string.Format(IniReadValue("迴圈", "位置1", Path));
                txt_Loop_PA2.Text = string.Format(IniReadValue("迴圈", "位置2", Path));
                txt_Loop_SP.Text = string.Format(IniReadValue("迴圈", "速度", Path));
                txt_Loop_AC.Text = string.Format(IniReadValue("迴圈", "加速度", Path));
                txt_Loop_DC.Text = string.Format(IniReadValue("迴圈", "減速度", Path));
                num_LoopCount.Value = Int32.Parse(IniReadValue("迴圈", "迴圈數", Path));
                txt_waittime.Text = string.Format(IniReadValue("迴圈", "等待時間", Path));

                return true;
            }
            catch
            {
                return false;
            }
        }

        #region 讀寫INI用

        [DllImport("kernel32")]
        private static extern long WritePrivateProfileString(string section, string key, string val, string filePath);
        [DllImport("kernel32")]
        private static extern int GetPrivateProfileString(string section, string key, string def, StringBuilder retVal, int size, string filePath);

        /// <summary>
        /// Write Data to the INI File
        /// </summary>
        /// <param name="Section"></param>
        /// Section name
        /// <param name="Key"></param>
        /// Key Name
        /// <param name="Value"></param>
        /// Value Name
        private static void IniWriteValue(string Section, string Key, string Value, string path)
        {
            WritePrivateProfileString(Section, Key, Value, path);
        }

        /// <summary>
        /// Read Data Value From the Ini File
        /// </summary>
        /// <param name="Section"></param>
        /// <param name="Key"></param>
        /// <param name="Path"></param>
        /// <returns></returns>
        private static string IniReadValue(string Section, string Key, string path)
        {
            StringBuilder temp = new StringBuilder(255);
            int i = GetPrivateProfileString(Section, Key, "", temp, 255, path);
            return temp.ToString();
        }

        #endregion 讀寫INI用

        #endregion

        private void Form1_Closing_Click(object sender, FormClosingEventArgs e)
        {
            if (pnl_MotionStatus_X.BackColor == Color.Red || pnl_MotionStatus_Y.BackColor == Color.Red ||
                pnl_MotionStatus_Z.BackColor == Color.Red || pnl_MotionStatus_W.BackColor == Color.Red)
            {
                MessageBox.Show("馬達運行中，請勿關閉程式。");
                e.Cancel = true;
            }
            else
            {
                if (MessageBox.Show("是否確定要關閉程式", "關閉程式", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {
                    try
                    {
                        G_thStatusChk.Abort();                 
                    }
                    catch
                    {
                    }
                }
                else
                {
                    e.Cancel = true;
                }
            }
        }

        private void btn_ErrorCodeClear_Click(object sender, EventArgs e)
        {
            txt_ErrorCode.Clear();
        }     

        private void btn_Loop_ST_Click(object sender, EventArgs e)
        {
            try
            {
                DMC_1.command("ST");
            }
            catch (System.Runtime.InteropServices.COMException ex)
            {
                txt_ErrorCode.Text = ex.Message.Trim();
            }
        }



    }




    
}
